<?php
/*
	SMG WebGUI

	Software distributed under the License is distributed on an "AS IS" basis,
	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
	for the specific language governing rights and limitations under the
	License.
	
	Licence information can be found within the file LICENCE.php
	
	The Original Code is SMG WebGUI

	The Initial Developer of the Original Code is
	Shaunt Libarian <shaunt@sangoma.com>

	Contributor(s):
	Shaunt Libarian <shaunt@sangoma.com>
*/

	//Starts PHP Sessions
	session_start();
if ($_SESSION['username'] != "")
{	
	$db_location = "sqlite:../sqlite/cardinfo.db";
	
	//Include Statements
	include '../database_classes.php';
	include 'ss7_linkset_view_profile_class.php';
	
	//PHP Class Constructors
	$data = new database_class;	
	$ss7_linkset_view = new ss7_linkset_view_profile_class;
	
	unset ($_SESSION['error']);
			
	//Check if a linkset/route/isup interface exists.
	$table_name = "ss7_linkset_profile";
	$where = "id = 1";
	$linkset_exist = $data->select_statement($db_location, $table_name, "profile_name", $where);

	$table_name = "ss7_route_profile";
	$where = "id = 1";
	$route_exist = $data->select_statement($db_location, $table_name, "profile_name", $where);
	
	$table_name = "ss7_isup_profile";
	$where = "id = 1";
	$isup_exist = $data->select_statement($db_location, $table_name, "profile_name", $where);

	if ($linkset_exist['profile_name'] == "" && $route_exist['profile_name'] == "" && $isup_exist['profile_name'] == "")
	{
		$_SESSION['skip_all'] = "yes";
		unset ($_SESSION['error']);		
		header( 'Location:create_ss7_linkset.php' );
	}
	elseif ($route_exist['profile_name'] == "" && $isup_exist['profile_name'] == "")
	{
		$_SESSION['skip_route'] = "yes";
		unset ($_SESSION['skip_all']);
		unset ($_SESSION['skip_isup']);
		unset ($_SESSION['error']);		
	}
	elseif ($isup_exist['profile_name'] == "")
	{
		unset ($_SESSION['skip_all']);
		unset ($_SESSION['skip_route']);
		unset ($_SESSION['error']);		
		$_SESSION['skip_isup'] = "yes";
	}
	elseif ($linkset_exist['profile_name'] == "")
	{
		$_SESSION['skip_all'] = "yes";
		unset ($_SESSION['skip_all']);
		unset ($_SESSION['skip_route']);
		unset ($_SESSION['error']);		
		unset ($_SESSION['skip_isup']);		
		header( 'Location:create_ss7_linkset.php' );
	}
			
	//Holds the number of entries variable
	$num_entries = $_SESSION['num_entries'];
	
	$_SESSION['id_num'] = "";
	
	//Starts the Wizard
	if (!isset($_SESSION['linkset']) && !isset($_SESSION['route']) && !isset($_SESSION['isup']))
	{
		$_SESSION['linkset'] = "Start";
		unset ($_SESSION['error']);		
	}
	
	//If back button pressed
	if ($_REQUEST['back'] == "Go Back to Hardware Information")
	{
		unset($_SESSION['next']);
		unset($_SESSION['last_profile']);
		unset ($_SESSION['linkset']);
		unset ($_SESSION['route']);
		unset ($_SESSION['last_profile']);
		unset ($_SESSION['last_route']);
		unset ($_SESSION['error']);		
		
		//Redirects to hardware probe
		header( 'Location:../wanrouterhwprobe.php' );
	}
	if ($_REQUEST['back-route'] == "Back to Linksets")
	{
		$_SESSION['linkset'] = "Start";
		unset ($_SESSION['isup']);
		unset ($_SESSION['route']);
		unset ($_SESSION['error']);		
		header( 'Location:view_ss7_linkset.php' );		
	}
	if ($_REQUEST['back-isup'] == "Back to Routes")
	{
		$_SESSION['linkset'] = "Done";
		unset($_SESSION['route']);
		unset($_SESSION['skip_isup']);
		unset ($_SESSION['error']);
		header( 'Location:view_ss7_linkset.php' );				
	}
	if ($_REQUEST['back-isup'] == "Finish")
	{
		if ($_SESSION['skip_isup'] != "")
		{
			$_SESSION['route'] = "Done";
			$_SESSION['error'] = "yes";
		}
		else
		{
			unset($_SESSION['last_profile']);
			unset ($_SESSION['linkset']);
			unset ($_SESSION['route']);
			unset ($_SESSION['last_profile']);
			unset ($_SESSION['skip_all']);
			unset ($_SESSION['skip_route']);
			unset ($_SESSION['skip_isup']);
			unset ($_SESSION['last_route']);
			unset ($_SESSION['error']);
			unset ($_SESSION['isup_created']);
			header( 'Location:../wanrouterhwprobe.php' );				
		}
	}	
	
	//If create profile clicked on
	if ($_REQUEST['create_linkset'] == "Create New Profile")
	{
		//Redirects to hardware probe
		header( 'Location:create_ss7_linkset.php' );
	}
	if ($_REQUEST['create_route'] == "Create New Profile")
	{
		//Redirects to hardware probe
		header( 'Location:create_ss7_route.php' );
	}
	if ($_REQUEST['create_isup'] == "Create New Profile")
	{
		//Redirects to hardware probe
		header( 'Location:create_ss7_isup.php' );
	}
	
	//Goes through the request variables and checks what was clicked on
	foreach ($_REQUEST as $key => $value)
	{	
		//Check to see if the Signalling table for that card exists
		$exists = $data->check_for_table ($db_location, $table_name);
		
		for ($x = 0; $x <= $num_entries+100; $x++)
		{
			if ($_REQUEST['back-route'] == "Continue to ISUP Interfaces")
			{
				  $_SESSION['last_route'] = $x;
				  unset($_SESSION['linkset']);
				  $_SESSION['route'] = "Done";
				  unset($_SESSION['last_profile']);
				  unset ($_SESSION['skip_route']);
				  
				  if ($_SESSION['skip_isup'] == "yes")
				  {
					  //echo "yes";
					  header( 'Location:create_ss7_isup.php' );
				  }	
			}	
			if ($_REQUEST['back-route'] == "Next")
			{
				  $_SESSION['linkset'] = "Done";
				  
				  unset($_SESSION['next']);
				  unset($_SESSION['last_route']);
				  unset($_SESSION['route']);
				  unset($_SESSION['last_profile']);
				  unset ($_SESSION['skip_route']);
				  
				  header( 'Location:view_ss7_linkset.php' );
			}			
			//$x = the ss7_profile line number			
			//Checks to see which Delete button was pressed
			if ($key == "delete-linkset$x" && $value == "Delete Linkset")
			{
				$table_name = "ss7_linkset_profile";
				$param = "id = $x";
				$data->delete_generic($db_location, $table_name, $param);
			}
			if ($key == "delete-route$x" && $value == "Delete Route")
			{
				$table_name = "ss7_route_profile";
				$param = "id = $x";
				$data->delete_generic($db_location, $table_name, $param);
			}
			if ($key == "delete-isup$x" && $value == "Delete ISUP Interface")
			{
				$table_name = "ss7_isup_profile";
				$param = "id = $x";
				$data->delete_generic($db_location, $table_name, $param);
				
				if ($x == 1)
				{
					unset($_SESSION['isup_created']);
				}
			}						
			if ($key == "config-linkset$x" && $value == "Edit Linkset")
			{
				//Takes the last value in the key to know the database ID number clicked
				$rest = substr($key, -1);
				
				//Sets the ID number into a session variable to go to the redirection and edit the profile
				$_SESSION['id_num'] = $rest;
			
				//Redirects to the create profile page
				header( 'Location:create_ss7_linkset.php' ) ;
			}
			if ($key == "config-route$x" && $value == "Edit Route")
			{
				//Takes the last value in the key to know the database ID number clicked
				$rest = substr($key, -1);
				
				//Sets the ID number into a session variable to go to the redirection and edit the profile
				$_SESSION['id_num'] = $rest;
			
				//Redirects to the create profile page
				header( 'Location:create_ss7_route.php' ) ;
			}
			if ($key == "config-isup$x" && $value == "Edit ISUP Interface")
			{
				//Takes the last value in the key to know the database ID number clicked
				$rest = substr($key, -1);
				
				//Sets the ID number into a session variable to go to the redirection and edit the profile
				$_SESSION['id_num'] = $rest;
			
				//Redirects to the create profile page
				header( 'Location:create_ss7_isup.php' ) ;
			}
			//Clicked when user wants to use a Linkset Profile
			if ($key == "use-linkset$x" && $value == "Bind Linkset")
			{
				//Check if the link being bound has the same link type, switchtype and unique SLC value as all the other links attached to this linkset
				//If the linkset is not tied to any link, allow it
				//If it isn't then check to make sure all the attached links have the same values
				//class redirection
				$ss7_linkset_view->clicked_id = $x;
				$ss7_linkset_view->check_linksets();
				
				if ($ss7_linkset_view->error_linkset == "pass")
				{	
					$port = $_SESSION['port_num_clicked'];
	
					$param = "profile_name";
					$where_param = "id = " . $x;
					$values = $data->select_statement ($db_location, "ss7_linkset_profile", $param, $where_param);
					
					$update_where = "port_id = $port";	
					$insert_param = "linkset";
					$update_param = "linkset = \"" . $values['profile_name'] . "\"";
					$insert_values = "\"" . $values['profile_name'] . "\"";													
				
					//Checks to see if the line exists
					$sig_param = "port_id = $port";
					
					$table_name =  $_SESSION['card_clicked'] . "_" . $_SESSION['card_num'] . "_SS7_link";
					$param = "port_id";
	
					$sig_info = $data->select_statement ($db_location, $table_name, $param, $sig_param);						
					
					if ($sig_info['port_id'] != "")
					{
						//Port ID found, please update that port
						$data->update_table($db_location,$table_name, $update_param, $update_where);
					}
					if ($sig_info['port_id'] == "")
					{
						//echo "I am here <br />";
						//Insert the line
						$data->insert_statement($db_location, $table_name, $insert_param, $insert_values);
					}						
					
					unset($_SESSION['last_profile']);
					$_SESSION['linkset'] = "Done";
					
					if ($_SESSION['skip_route'] == "yes")
					{
						header( 'Location:create_ss7_route.php' );
					}
				}
			}
		}
	}


	//FusionPBX Integration
	require_once "../fusionpbx/includes/header.php";

	//Display the profiles for the matching connection type (PTP/PTMP)
	$ss7_linkset_view->display_profiles();
	
	//FusionPBX Integration
	require_once "../fusionpbx/includes/footer.php";	
}
else
{
	header( 'Location:../index.php' ) ;
}	
?>