<?php
/*
	SMG WebGUI

	Software distributed under the License is distributed on an "AS IS" basis,
	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
	for the specific language governing rights and limitations under the
	License.
	
	Licence information can be found within the file LICENCE.php
	
	The Original Code is SMG WebGUI

	The Initial Developer of the Original Code is
	Shaunt Libarian <shaunt@sangoma.com>

	Contributor(s):
	Shaunt Libarian <shaunt@sangoma.com>
*/

session_start();
//include 'database_classes.php';

class ss7_display extends database_class
{
	public $card_num="";				//Contains the card number
	public $port_count="";				//Contains the port count
	public $card_name="";				//Contains the card name
	private $ss7_linksets = array();	//Contains all the ss7 linksets
	private $ss7_routes = array();		//Contains all the ss7 ISUP Interfaces
	private $ss7_isups = array();		//Contains all the ss7 Routes
	private $ss7_ccspans = array();		//Contains all the ss7 CCSpans
	private $counter_linkset="";		//Linkset Counter variable
	private $counter_route="";			//Route Counter variable
	private $counter_isup="";			//ISUP Counter variable
	public $ss7_linkset="";				//Contains the SS7 Linkset chosen by the user
	private $token_card_name="";		//Contains the card name tokenized
	private $ss7_voicelink="";			//Variable that shows whether the link is a voicelink or not
	public $line_type="";				//T1/E1 line type
	
	//Main Display function for the SS7 Class
	function main()
	{
		
		//Tokenizes the card name for use
		$this->token_cardname();
		
		//Master Table Separations (Needed to seperate the specific tables)
		echo "\t\t</td>\n";
		echo "\t\t<td>\n";	
		
		//Gets information from the database
		$this->get_chosen_linkset();
		$this->get_linkset_list();
		$this->get_isup_list();
		$this->get_route_list();
		$this->check_voicelink();
		
		if ($this->ss7_voicelink != "yes")
		{
			echo "\t\t<table border=\"1\" width=\"140px\" height=\"70px\">\n";
			echo "\t\t\t<tr>\n";
			echo "\t\t\t\t<td><b>SS7 Config</b>:";
			echo "\t\t\t\t<br />\n";			
			
			if ($this->ss7_linkset['linkset']!="")
			{
				echo "\t\t\t\t --> " . $this->ss7_linkset['linkset'] . "\n";
				/*
				?>
					<select name="linkset-<?php echo $this->card_name . "-". $this->port_count . "-" . $this->card_num; ?>">
				<?php
				for ($a = 0; $a < $this->counter; $a++)
				{ 
						echo "<option value=\"" . $this->ss7_linksets[$a]['profile_name'] . "\""; if ($this->ss7_linkset['linkset'] == $this->ss7_linksets[$a]['profile_name']) { ?> selected="selected" <?php } echo " >" . $this->ss7_linksets[$a]['profile_name'] . "</option>\n";
				}
				?>
				   </select>
				<?php			
				*/
			}
			echo "\t\t\t\t</td>\n";
			echo "\t\t\t<td align=\"center\">\n";
			echo "<input type=\"submit\" name=\"config-linkset-" . $this->card_name . "-". $this->port_count . "-" . $this->card_num . "-" . $_SESSION['span_num'] . "\" value=\"Edit\" style=\"background-color: #CCC\"/>\n";	
	
			//Creates the Update button for linksets
			if (isset ($this->ss7_linksets[0]))
			{
				//echo "<input type=\"submit\" name=\"ss7linkset-accept-" . $this->card_name . "-". $this->port_count . "-" . $this->card_num . "-" . $_SESSION['span_num'] . "\" value=\"Accept\" />\n";
			}
			echo "\t\t\t</td>\n";
			echo "\t\t\t</tr>\n";
			echo "\t\t</table>\n";
			//Master Table Separations (Needed to seperate the specific tables)
			echo "\t\t</td>\n";
			echo "\t\t<td>\n";				
		}
		
		//Check whether there are linksets/routes/isups defined
		for ($a = 0; $a <= $this->counter_isup; $a++)
		{
			if ($this->ss7_isups[$a]['profile_name'] != "")
			{
				$ok_isup = "ok";
			}
		}
		for ($a = 0; $a <= $this->counter_linksets; $a++)
		{
			if ($this->ss7_linksets[$a]['profile_name'] != "")
			{
				$ok_linkset = "ok";
			}
		}
		for ($a = 0; $a <= $this->counter_route; $a++)
		{
			if ($this->ss7_routes[$a]['profile_name'] != "")
			{
				$ok_route = "ok";
			}
		}

		//echo "linkeset = " . $ok_linkset . " route = $ok_route isup = $ok_isup<br />";
		
		if ($this->ss7_linkset['linkset'] != "" || $this->ss7_voicelink == "yes")
		{
			if ($ok_linkset == "ok" && $ok_route == "ok" && $ok_isup == "ok")
			{
				$this->get_ccspans();
				//echo "ccspan isup = " . $this->ss7_ccspans['isup'];
				if ($this->ss7_ccspans['isup'] == "")
				{
					echo "\t\t<table border=\"1\" width=\"160px\" height=\"70px\">\n";
					echo "\t\t\t<tr>\n";
					echo "\t\t\t\t<td>\n";
					echo "Channel Configuration<br />";
					echo "<td align=\"center\"><input type=\"submit\" name=\"config-ss7ccspan-" . $this->card_name . "-". $this->port_count . "-" . $this->card_num . "-" . $_SESSION['span_num'] . "\" value=\"Edit\" style=\"background-color: #CCC\"/></td>\n";			
					echo "\t\t\t</tr>\n";
					echo "\t\t</table>\n";					
				}
				else
				{
					echo "\t\t<table border=\"1\" width=\"330px\" height=\"70px\">\n";
					echo "\t\t\t<tr>\n";
					echo "\t\t\t\t<td>\n";
					//echo "<b>Channel Configuration</b>:";
					//echo "\t\t\t\t<br />\n";
					echo "\t\t\t\t<table border=\"0\">\n";
					echo "\t\t\t\t\t<tr>\n";
					echo "\t\t\t\t\t\t<td align=\"center\">Channel Map</td>\n";
					echo "\t\t\t\t\t\t<td align=\"center\">CiC</td>\n";
					echo "\t\t\t\t\t\t<td align=\"center\">Group</td>\n";
					echo "\t\t\t\t\t\t<td align=\"center\">ISUP Interface</td>\n";									
					echo "\t\t\t\t\t</tr>\n";
					echo "\t\t\t\t\t<tr>\n";		
					//<input type=\"text\" name=\"channel-map-" . $card_name . "-". $port[$count] . "-" . $span . "\" style=\"width:100px\" value=\"$channels\" readonly=\"readonly\" />	
					if ($this->ss7_voicelink == "yes")
					{
						if ($this->ss7_ccspans['channels'] != "")
						{
							$this->channels = $this->ss7_ccspans['channels'];
						}
						elseif ($this->line_type == "T1")
						{
							$this->channels = "1-24";
						}
						elseif ($this->line_type == "E1")
						{
							$this->channels = "1-31";
						}
					}
					else
					{
						$this->channels = $this->ss7_ccspans['channels'];
					}
					echo "\t\t\t\t\t\t<td><input type=\"text\" name=\"channel-map-" . $this->card_name . "-". $this->port_count . "-" . $this->card_num . "-" . $_SESSION['span_num'] . "\" style=\"text-align:right; width:100px\" value=\"" . $this->channels . "\" readonly=\"readonly\" /></td>\n";
					echo "\t\t\t\t\t\t<td align=\"center\"><input type=\"text\" name=\"cic-" . $this->card_name . "-". $this->port_count . "-" . $this->card_num . "-" . $_SESSION['span_num'] . "\" style=\"text-align:right; width:30px\" value=\"" . $this->ss7_ccspans['cic'] . "\" readonly=\"readonly\" /></td>\n";					
					echo "\t\t\t\t\t\t<td align=\"center\"><input type=\"text\" name=\"group-" . $this->card_name . "-". $this->port_count . "-" . $this->card_num . "-" . $_SESSION['span_num'] . "\" style=\"text-align:right; width:30px\" value=\"" . $this->ss7_ccspans['group_num'] . "\" readonly=\"readonly\" /></td>\n";
					echo "\t\t\t\t\t\t<td align=\"center\">" . $this->ss7_ccspans['isup'] . "</td>\n";											
					echo "\t\t\t\t\t</tr>\n";
					echo "\t\t\t\t</table>\n";
					echo "<td align=\"center\"><input type=\"submit\" name=\"config-ss7ccspan-" . $this->card_name . "-". $this->port_count . "-" . $this->card_num . "-" . $_SESSION['span_num'] . "\" value=\"Edit\" style=\"background-color: #CCC\"/></td>\n";			
					echo "\t\t\t</tr>\n";
					echo "\t\t</table>\n";
					$_SESSION['create'] = "yes";
				}
			}
			else
			{	
				echo "\t\t<table border=\"1\" width=\"130px\" height=\"63px\">\n";
				echo "\t\t\t<tr>\n";
				echo "\t\t\t\t<td><font color=\"red\"><b>Error: Please Configure a Linkset, Route and ISUP interface</b></td>";		
				echo "\t\t\t</tr>\n";
				echo "\t\t</table>\n";
			}
		}
		//Master Table Separations (Needed to seperate the specific tables)
		echo "\t\t</td>\n";
		//echo "\t\t<td>\n";	
		if ($this->ss7_ccspans['group_num'] > 1)
		{
			$_SESSION['group']++;
		}
	}
	
	
	//function that retrieves SS7 Linkset Information
	function get_linkset_list()
	{
		$db_location = "sqlite:sqlite/cardinfo.db";
		$table_name = "ss7_linkset_profile";
		$a = 0;

		$select = "SELECT profile_name FROM " . $table_name . ";";
		
		try
		{
			//open the database
			$db = new PDO($db_location);

			$result = $db->query($select);
		
		    foreach($result as $row)
		    {
				//echo $row['profile_name'];
				$this->ss7_linksets[$a] = $row;
				$a++;
			}
			// close the database connection
			$db = NULL;
			}
		catch(PDOException $e)
		{
			print 'Exception : '.$e->getMessage();
		}
		
		$this->counter_linkset = $a;
	}
	
	//Gets all the ISUP Interface names
	function get_isup_list()
	{
		$db_location = "sqlite:sqlite/cardinfo.db";
		$table_name = "ss7_isup_profile";
		$a = 0;

		$select = "SELECT profile_name FROM " . $table_name . ";";
		
		try
		{
			//open the database
			$db = new PDO($db_location);

			$result = $db->query($select);
		
		    foreach($result as $row)
		    {
				//echo $row['profile_name'];
				$this->ss7_isups[$a] = $row;
				$a++;
			}
			// close the database connection
			$db = NULL;
			}
		catch(PDOException $e)
		{
			print 'Exception : '.$e->getMessage();
		}
		
		$this->counter_isup = $a;		
	}
	
	//Gets all the Route Names
	function get_route_list()
	{
		$db_location = "sqlite:sqlite/cardinfo.db";
		$table_name = "ss7_route_profile";
		$a = 0;

		$select = "SELECT profile_name FROM " . $table_name . ";";
		
		try
		{
			//open the database
			$db = new PDO($db_location);

			$result = $db->query($select);
		
		    foreach($result as $row)
		    {
				//echo $row['profile_name'];
				$this->ss7_routes[$a] = $row;
				$a++;
			}
			// close the database connection
			$db = NULL;
			}
		catch(PDOException $e)
		{
			print 'Exception : '.$e->getMessage();
		}
		
		$this->counter_route = $a;		
	}

	//Grabs the chosen linkset from the database
	function get_chosen_linkset()
	{	
		$where = "port_id = " . $this->port_count;
		$table_name = $this->token_card_name . "_" . $this->card_num . "_SS7_link";
		
		$this->ss7_linkset = parent::select_statement("sqlite:sqlite/cardinfo.db",$table_name, "linkset", $where);
	}
	
	function get_ccspans()
	{
		$where = "port_id = " . $this->port_count;
		$table_name = $this->token_card_name . "_" . $this->card_num . "_SS7_ccspans";
		$param = "isup, cic, channels, group_num";
		$this->ss7_ccspans = parent::select_statement("sqlite:sqlite/cardinfo.db",$table_name, $param, $where);		
	}
	
	function check_voicelink()
	{
		$where = "port_id = " . $this->port_count;
		$table_name = $this->token_card_name . "_" . $this->card_num . "_SS7_link";
		
		$value = parent::select_statement("sqlite:sqlite/cardinfo.db",$table_name, "voice", $where);		
		
		$this->ss7_voicelink = $value['voice'];
		
	}
	
	//Tokenizes the card name
	function token_cardname()
	{
		$tok = strtok($this->card_name, "-");

		$count = 0;
		while ($tok !== false) 
		{
			$token[$count] = $tok;
		    $tok= strtok(",");
			$count++;
		}
		
		$this->token_card_name = $token[0];
	}
}

?>